wiki:PythonOcc/elbow

Version 13 (modified by Leon Kos, 7 years ago) (diff)

Chamfer

Komolec

Koordinatni sistem Na primeru komolca bomo pokazali osnovne operacije in gradnjo modela s PythonOcc za postavitev v globalnem koordinatnem sistemu podanem s tremi točkami:

  • p0 - središče komolca
  • p1 - točka ki podaja os axis1 iz središča p0
  • p2 - točka za drugo os axis2 iz središča p0

Cilj takega podajanja položaja je, da se poenostavi orientacijo in s tem tudi gradnjo sestavov iz tega in podobnih členkov. Model na skici naj bi omogočal tudi enostavno gradnjo sestavov. Skica kolena

Poleg globalnega določanja položaja želimo nadzorovati tudi stopnjo izdelave podrobnosti, saj se nekateri detajli ne potrebujejo za vse namene. Poglaviten namen je predvsem prikaz v sestavu. Takrat nahko zmanjšamo podrobnosti zaokrožitev in notranjosti.

Pričnemo z manjšim programom na katerega bomo postopoma dograjevali model. Kot osnovo vzamemo program s cilindrom. Osnutek

from OCC.Display.SimpleGui import *
from OCC.BRepPrimAPI import *
R = 30
L = 150
myPrim1 = BRepPrimAPI_MakeCylinder(R, L)
(display, start_display, add_menu, add_function_to_menu) = init_display()
display.DisplayShape(myPrim1.Shape())
start_display()

Za izdelavo cilindra smo uporabili API ukaze iz nabora OCC.BRepPrimAPI, ki poenostavljajo gradnjo osnovnih primitivov brez gradnje topologije. Prav tako je potrebno poudariti, da zaradi objektnega programiranja uporabimo različne izpeljanke iste funkcije. Tako je BRepPrimAPI_MakeCylinder možno klicati v naslednjih oblikah:

BRepPrimAPI_MakeCylinder(Standard_Real R, Standard_Real H) 
BRepPrimAPI_MakeCylinder(Standard_Real R, Standard_Real H, Standard_Real Angle)
BRepPrimAPI_MakeCylinder(gp_Ax2 Axes, Standard_Real R, Standard_Real H)
BRepPrimAPI_MakeCylinder(gp_Ax2 Axes, Standard_Real R, Standard_Real H, Standard_Real Angle)

kar lahko preverimo, če v Python Shell napišemo

>>> from OCC.BRepPrimAPI import *
>>> help(BRepPrimAPI_MakeCylinder)

ali si ogledamo spletna navodila za BRepPrimAPI_MakeCylinder. Za naš namen postavljanja cilindra v globalni prostor je primernejša funkcija s parametri, ki poda še os poleg premera in višine. Za podajanje osi gp_Ax2 se uporablja dva 3D vektorja. Prvi je izhodiščni položaj drugi pa usmeritev. Vsi ti vektorja so podani v knjižnici gp (general purpose). Knjižnica gp podpira različne tipe vektorjev od 2D do 3D čeprav so načeloma istega ranka predvsem zaradi tega, da se da enostavno pretvarjati iz enega tipa v drugi. Tako imamo v gp_Ax2 točko in smerni vektor, ki sestavlja podatka za os. Običajno je tako, da najprej pogledamo možne izpeljane funkcije in izberemo inačico z nam najprimernejšimi podatki. Nato glede na zahtevane vhodne argumente pripravimo v obliki, ki je najkrajša in ustreza namenu. Prav tako želimo pripraviti model tako, da se glavne dimenzije postavi kot parametre s katerimi lahko enostavno spremenimo model. V našem primeru sta to R in L. Razširitev programa s knjižnico gp je naslednja

from OCC.gp import *
from OCC.Display.SimpleGui import *
from OCC.BRepPrimAPI import *

R = 30
L = 150
p = gp_Pnt(0., 0., 0.)
d = gp_Dir(1., 0., 0.) 
myAxes1 = gp_Ax2(p,d) 
myPrim1 = BRepPrimAPI_MakeCylinder(myAxes1, R, L)
(display, start_display, add_menu, add_function_to_menu) = init_display()
display.DisplayShape(myPrim1.Shape())
start_display()

Srebren model Podobno kot pri gradnji primitiva lahko prikaz cilindra dopolnimo s spremembo barve ali predpisani lastnosti materiala površine s tem da uporabimo

display.DisplayColoredShape(myPrim1.Shape(), 'CYAN')

ali

from OCC.Graphic3d import *
#...
material = Graphic3d_MaterialAspect(Graphic3d_NOM_SILVER)
display.DisplayShape(myPrim1.Shape(), material)

Za izdelavo posnetja je potrebno podati ploskev in rob. Chamfer

mkFillet = BRepFilletAPI_MakeChamfer(myPrim1.Shape())
ex = TopExp_Explorer(myPrim1.Shape(), TopAbs_EDGE)
ex2 = TopExp_Explorer(myPrim1.Shape(), TopAbs_FACE)
edge = TopoDS_edge(ex.Current())
face = TopoDS_face(ex2.Current())
mkFillet.Add(15.0, 3.0, edge, face)
#...
display.DisplayColoredShape(mkFillet.Shape(), 'BLUE')

in naslednje vključke na vrhu

from OCC.BRepFilletAPI import *
from OCC.Utils.Topology import Topo
from OCC.TopExp import *
from OCC.TopAbs import *
from OCC.TopoDS import *

Attachments (16)

Download all attachments as: .zip